---
title: <display-box>
slug: Web/CSS/display-box
tags:
  - CSS
  - CSS Data Type
  - CSS Display
  - Data Type
  - Reference
  - display-box
---
<div>{{CSSRef}}</div>

<p class="summary">These keywords define whether an element generates display boxes at all.</p>

<h2 id="Syntax">Syntax</h2>

<p>Valid <code>&lt;display-box&gt;</code> values:</p>

<dl>
 <dt><code>contents</code> {{Experimental_Inline}}</dt>
 <dd>These elements don't produce a specific box by themselves. They are replaced by their pseudo-box and their child boxes. Please note that the CSS Display Level 3 spec defines how the <code>contents</code> value should affect "unusual elements" — elements that aren’t rendered purely by CSS box concepts such as replaced elements. See <a href="https://drafts.csswg.org/css-display/#unbox">Appendix B: Effects of display: contents on Unusual Elements</a> for more details.<br>
 <br>
 <em>Due to a bug in browsers this will currently remove the element from the accessibility tree — screen readers will not look at what's inside. See the <a href="#Accessibility_concerns">Accessibility concerns</a> section below for more details.</em></dd>
 <dt><code>none</code></dt>
 <dd>Turns off the display of an element so that it has no effect on layout (the document is rendered as though the element did not exist). All descendant elements also have their display turned off.<br>
 To have an element take up the space that it would normally take, but without actually rendering anything, use the {{CSSxRef("visibility")}} property instead.</dd>
</dl>

<h2 id="Accessibility_concerns">Accessibility concerns</h2>

<p>Current implementations in most browsers will remove from the <a href="/en-US/docs/Learn/Accessibility/What_is_accessibility#Accessibility_APIs">accessibility tree</a> any element with a <code>display</code> value of <code>contents</code>. This will cause the element — and in some browser versions, its descendant elements — to no longer be announced by screen reading technology. This is incorrect behavior according to the <a href="https://drafts.csswg.org/css-display/#the-display-properties">CSSWG specification</a>.</p>

<ul>
 <li><a class="external" href="https://hiddedevries.nl/en/blog/2018-04-21-more-accessible-markup-with-display-contents">More accessible markup with display: contents | Hidde de Vries</a></li>
 <li><a class="external" href="http://adrianroselli.com/2018/05/display-contents-is-not-a-css-reset.html">Display: Contents Is Not a CSS Reset | Adrian Roselli</a></li>
</ul>

<h2 id="Examples">Examples</h2>

<p>In this first example, the paragraph with a class of secret is set to <code>display: none</code>; the box and any content is now not rendered.</p>

<h3 id="display_none">display: none</h3>

<h4 id="HTML">HTML</h4>

<pre class="brush: html notranslate">&lt;p&gt;Visible text&lt;/p&gt;
&lt;p class="secret"&gt;Invisible text&lt;/p&gt;</pre>

<h4 id="CSS">CSS</h4>

<pre class="brush: css notranslate">p.secret {
  display: none;
}</pre>

<h4 id="Result">Result</h4>

<p>{{EmbedLiveSample("display_none", "100%", 60)}}</p>

<h3 id="display_contents">display: contents</h3>

<p>In this example the outer {{htmlelement("div")}} has a 2-pixel red border and a width of 300px. However it also has <code>display: contents</code> specified therefore this <code>&lt;div&gt;</code> will not be rendered, the border and width will no longer apply, and the child element will be displayed as if the parent had never existed.</p>

<h4 id="HTML_2">HTML</h4>

<pre class="brush: html notranslate">&lt;div class="outer"&gt;
  &lt;div&gt;Inner div.&lt;/div&gt;
&lt;/div&gt;
</pre>

<h4 id="CSS_2">CSS</h4>

<pre class="brush: css notranslate">.outer {
  border: 2px solid red;
  width: 300px;
  display: contents;
}

.outer &gt; div {
  border: 1px solid green;
}
</pre>

<h4 id="Result_2">Result</h4>

<p>{{EmbedLiveSample("display_contents", 300, 60)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('CSS3 Display', '#typedef-display-box', 'display-box')}}</td>
   <td>{{Spec2('CSS3 Display')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div class="hidden">The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out <a class="external" href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</div>

<h3 id="Support_of_contents">Support of contents</h3>

<p>{{Compat("css.properties.display.contents", 10)}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{CSSxRef("display")}}
  <ul>
   <li>{{CSSxRef("&lt;display-outside&gt;")}}</li>
   <li>{{CSSxRef("&lt;display-inside&gt;")}}</li>
   <li>{{CSSxRef("&lt;display-listitem&gt;")}}</li>
   <li>{{CSSxRef("&lt;display-internal&gt;")}}</li>
   <li>{{CSSxRef("&lt;display-legacy&gt;")}}</li>
  </ul>
 </li>
 <li><a href="http://adrianroselli.com/2018/05/display-contents-is-not-a-css-reset.html">Display: Contents Is Not a CSS Reset | Adrian Roselli</a></li>
 <li><a href="https://hiddedevries.nl/en/blog/2018-04-21-more-accessible-markup-with-display-contents">More accessible markup with display: contents — hiddedevries.nl</a></li>
</ul>
